import com.ms.xml.ParseException;
import com.ms.xml.Attribute;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.io.*;
import java.io.PrintStream;
import java.net.*;

class attlist
{
    static String filename;

    public static void main(String args[])
    {        
        filename = "file:////c://xml//attlist//attlist.xml";

        URL url = null;
        try {
            url = new URL(filename);
        } 
        catch (MalformedURLException e) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e) {
            d.reportError(e, System.out);
        }

        if (d != null) {
            doTree(d.getRoot(), "");
        }
    }

    static void doTree(Element elem, String indent)
    {
        String attribString = " Attributes: ";
        Enumeration attribEnum = elem.getAttributes();
        while (attribEnum.hasMoreElements()) {
            Attribute attrib = ((Attribute)attribEnum.nextElement());
            attribString += attrib.getName() + " = " + attrib.getValue() + " ";
        }

        System.out.println(indent + elem.getTagName() + attribString);

        if(elem.numElements() > 1){
            Enumeration enum = elem.getChildren();
            while (enum.hasMoreElements()) {
                Element elem2 = (Element)enum.nextElement();
                doTree(elem2, indent + "   ");
            }
        }
    }
}    
