import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.io.*;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class birds extends Applet{

    static String filename;    
    Label birdLabel, dateLabel;
    TextField text1, text2;
    Button button1, button2, button3, button4;
    Document d;
    int currentRecordNumber = 0;
    int maxRecordNumber = 4;
    public static void main(String args[])
    {
        birdsFrame frame = new birdsFrame("The birds application");

        frame.show();
        frame.hide();
        frame.resize(330, 320);

        birds applet = new birds();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init()
    {
        birdLabel = new Label("Bird:");
        add(birdLabel);
        text1 = new TextField(30);
        add(text1);
        dateLabel = new Label("Date:");
        add(dateLabel);
        text2 = new TextField(30);
        add(text2);
        button1 = new Button("<");
        add(button1);
        button2 = new Button("Add record");
        add(button2);
        button3 = new Button("Save database");
        add(button3);
        button4 = new Button(">");
        add(button4);

        URL url = null;
        try {
            url = new URL("file:////c://xml//birds//birds.xml");
        } 
        catch (MalformedURLException e1) {
            System.out.println("Cannot create url for: " + filename);
            System.exit(0);
        }
            
        d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            maxRecordNumber = d.getRoot().numElements() - 1;
            showRecord(0);
        }
    }

    public boolean action (Event e, Object o){

        if(e.target.equals(button1)){  //The < button
            if(currentRecordNumber > 0){
                currentRecordNumber--;
            }
            showRecord(currentRecordNumber);
        }

        if(e.target.equals(button2)){  //The Add record button

            Element elem = d.createElement(new String("SIGHTING"), Element.ELEMENT);

            Element t1 = d.createElement(new String("BIRD"), Element.ELEMENT);
            Element x1 = d.createElement(null, Element.PCDATA);
            x1.setText(text1.getText());
            t1.addChild(x1, null);

            Element t2 = d.createElement(new String("DATE"), Element.ELEMENT);
            Element x2 = d.createElement(null, Element.PCDATA);
            x2.setText(text2.getText());
            t2.addChild(x2, null);

            elem.addChild(t1,null);
            elem.addChild(t2,null);
            d.getRoot().addChild(elem, null); 
            maxRecordNumber++;
        }

        if(e.target.equals(button3)){  //The Save database button

            FileOutputStream outstream = null;

            try {
                outstream = new FileOutputStream("birds.xml");
            } 
            catch (java.io.IOException ex) {
                System.out.println("Could not create file input stream.");
            }

            d.save(outstream);

            try {
                outstream.close();
            }
            catch (java.io.IOException ex) {
                System.out.println("IO exception");
            }

        }
        
        if(e.target.equals(button4)){  //The > button
            if(currentRecordNumber < maxRecordNumber){
                currentRecordNumber++;
            }
            showRecord(currentRecordNumber);
        }

        return true;
   }

   void showRecord(int recordNumber)
   {
        Element root = d.getRoot();
        Element elem = null, elem2 = null;
        Enumeration enum = root.getChildren();
        for(int index = 0; index <= recordNumber; index++){
            elem = (Element)enum.nextElement();
        }

        Enumeration enum2 = elem.getChildren();
        for(int index = 0; index < 2; index++){

            elem2 = (Element)enum2.nextElement();

            if (elem2.getTagName().equals("BIRD")) {
                text1.setText(elem2.getText());
            }

            if (elem2.getTagName().equals("DATE")) {
                text2.setText(elem2.getText());
            }
        }
    }
}    

class birdsFrame extends Frame
{
    public birdsFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

