import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class link extends Applet{

    static String filename;    
    TextField text1;
    Button button1;

    public static void main(String args[])
    {
        linkFrame frame = new linkFrame("The link application");

        frame.show();
        frame.hide();
        frame.resize(320, 320);

        link applet = new link();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        text1 = new TextField(20);
        add(text1);
        button1 = new Button("Jump to the hyperlinked document");
        add(button1);
    }

    public boolean action (Event e, Object o){

        URL url = null;
        filename = "file:////c://xml//link//link.xml";
        try {
            url = new URL(filename);
        } catch (MalformedURLException e1) {
            System.out.println("Cannot create url for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e2) {
            d.reportError(e2, System.out);
        }

        if (d != null) {
            Element root = d.getRoot();
            Enumeration enum = root.getChildren();
            while (enum.hasMoreElements()) {
                Element elem = (Element)enum.nextElement();
                if (elem.getTagName().equals("A")) {

                    URL url2 = null;

                    try {
                        url2 = new URL(elem.getAttribute("HREF"));
                    } 
                    catch (MalformedURLException e3) {
                        System.out.println("Cannot create URL for: " + elem.getAttribute("HREF"));
                        System.exit(0);
                    }
            
                    Document d2 = new Document(); 

                    try {
                        d2.load(url2);
                    } 
                    catch (ParseException e4) {
                        d2.reportError(e4, System.out);
                    }

                    text1.setText(d2.getText());
                }
            }
        }
        return true;
    }
}    

class linkFrame extends Frame
{
    public linkFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

