import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class radios extends Applet{

    static String filename;    
    static String displayStrings[] = new String[100];
    static int numberDisplayLines = 0;
    Checkbox radio1, radio2, radio3;
    CheckboxGroup checkboxgroup;

    public static void main(String args[])
    {
        radiosFrame frame = new radiosFrame("The radios application");

        frame.show();
        frame.hide();
        frame.resize(320, 240);

        radios applet = new radios();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        checkboxgroup = new CheckboxGroup();
        radio1 = new Checkbox("Document 1", checkboxgroup, false);
        add(radio1);
        radio2 = new Checkbox("Document 2", checkboxgroup, false);
        add(radio2);
        radio3 = new Checkbox("Document 3", checkboxgroup, false);
        add(radio3);
    }

    public boolean action (Event e, Object o)
    {
        numberDisplayLines = 0;
        URL url = null;

        try {
            if(e.target.equals(radio1)){
                url = new URL("file:////c://xml//radios//radios1.xml");
            }
            if(e.target.equals(radio2)){
                url = new URL("file:////c://xml//radios//radios2.xml");
            }
            if(e.target.equals(radio3)){
                url = new URL("file:////c://xml//radios//radios3.xml");
            }
        } 
        catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 
        try {
            d.load(url);
        }
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            doTree(d.getRoot(), "");
            repaint();
        }
        return true;
    }

    void doTree(Element elem, String indent)
    {
        String ind = "";

        Enumeration enum = elem.getChildren();

        while (enum.hasMoreElements()) {
            Element elem2 = (Element)enum.nextElement();

            if(elem2.getType() != com.ms.xml.Element.ELEMENT){
                int textLength = elem2.getText().length();
                displayStrings[numberDisplayLines++] = indent + elem2.getText().substring(0, textLength);
            }
            else{

                if(elem2.getTagName().equals("INDENTDOUBLE")){
                    ind = indent + "    ";
                }
                if(elem2.getTagName().equals("INDENT")){
                    ind = indent + "  ";
                }
                doTree(elem2, ind);
            }
        }
    }

    public void paint(Graphics g)
    {
        int y = 30;
        FontMetrics fontmetrics = getFontMetrics(getFont());

        for(int index = 0; index < numberDisplayLines; index++){
            y += fontmetrics.getHeight();
            g.drawString(displayStrings[index], 0, y);
        }
    }
}    

class radiosFrame extends Frame
{
    public radiosFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

